<?php
// Perfdata Sub-Component Functions
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: perfdata.php 75 2010-04-01 19:40:08Z egalstad $

include_once(dirname(__FILE__).'/../componenthelper.inc.php');


// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);

route_request();

function route_request(){

	$cmd=grab_request_var("cmd","");
	
	switch($cmd){
		case "getimage":
			perfdata_get_graph_image();
			break;
		default:
			echo "NOTHING TO DO!";
			break;
		}
	}
	

function perfdata_get_graph_image(){
	
	$hostname=grab_request_var("host","");
	$servicename=grab_request_var("service","");
	$source=grab_request_var("source",1);
	$view=grab_request_var("view",PNP_VIEW_DEFAULT);
	$start=grab_request_var("start","");
	$end=grab_request_var("end","");
	
	perfdata_get_graph_image_by_proxy($hostname,$servicename,$source,$view,$start,$end);
	}
	
// returns an image of a performance graph (using proxy to PNP)
function perfdata_get_graph_image_by_proxy($hostname="",$servicename="",$source=1,$view=PNP_VIEW_DEFAULT,$start="",$end=""){

	// need at least a hostname
	if($hostname=="")
		return;

	$url=pnp_get_direct_pnp_image_url($hostname,$servicename,$source,$view,$start,$end);
	
	//echo "URL: $url<BR>";
	
	pnp_do_proxy($url,$queryargs=null);
	}
	
	

?>